diff --git a/packages/datasource-engine/src/core/RuntimeDataSource.ts b/packages/datasource-engine/src/core/RuntimeDataSource.ts
new file mode 100644
index 000000000..8f53b45f7
--- /dev/null
+++ b/packages/datasource-engine/src/core/RuntimeDataSource.ts
@@ -0,0 +1,91 @@
+import { DataSourceOptions, IRuntimeDataSource, RequestHandler, RuntimeDataSourceStatus } from '../types';
+import { DataSourceResponse } from '../types/DataSourceResponse';
+
+export class RuntimeDataSource<
+  TParams extends Record<string, unknown> = Record<string, unknown>,
+  TRequestResult = unknown,
+  TResultData = unknown
+> implements IRuntimeDataSource<TParams, TResultData> {
+  private _status: RuntimeDataSourceStatus = RuntimeDataSourceStatus.Initial;
+  private _data?: TResultData;
+  private _error?: Error;
+  private _latestOptions: DataSourceOptions<TParams>;
+
+  constructor(
+    private _id: string,
+    private _type: string,
+    private _initialOptions: DataSourceOptions<TParams>,
+    private _requestHandler: RequestHandler<DataSourceOptions<TParams>, DataSourceResponse<TRequestResult>>,
+    private _dataHandler:
+      | ((
+          data: DataSourceResponse<TRequestResult> | undefined,
+          error: unknown | undefined,
+        ) => TResultData | Promise<TResultData>)
+      | undefined,
+    private _onLoaded: (data: TResultData) => void,
+  ) {
+    this._latestOptions = _initialOptions;
+  }
+
+  public get status() {
+    return this._status;
+  }
+
+  public get data() {
+    return this._data;
+  }
+
+  public get error() {
+    return this._error;
+  }
+
+  public async load(params?: TParams): Promise<TResultData> {
+    try {
+      this._latestOptions = {
+        ...this._latestOptions,
+        params: {
+          ...this._latestOptions.params,
+          ...params,
+        } as TParams,
+      };
+
+      this._status = RuntimeDataSourceStatus.Loading;
+
+      const data = await this._request(this._latestOptions);
+
+      this._status = RuntimeDataSourceStatus.Loaded;
+
+      this._onLoaded(data);
+
+      this._data = data;
+      return data;
+    } catch (err) {
+      this._error = err;
+      this._status = RuntimeDataSourceStatus.Error;
+      throw err;
+    }
+  }
+
+  public setOptions(options: DataSourceOptions<TParams>) {
+    this._latestOptions = options;
+  }
+
+  private async _request(options: DataSourceOptions<TParams>) {
+    try {
+      const response = await this._requestHandler(options);
+
+      const data = this._dataHandler
+        ? await this._dataHandler(response, undefined)
+        : ((response.data as unknown) as TResultData);
+
+      return data;
+    } catch (err) {
+      if (this._dataHandler) {
+        const data = await this._dataHandler(undefined, err);
+        return data;
+      }
+
+      throw err;
+    }
+  }
+}
diff --git a/packages/datasource-engine/src/core/index.ts b/packages/datasource-engine/src/core/index.ts
new file mode 100644
index 000000000..fb9854290
--- /dev/null
+++ b/packages/datasource-engine/src/core/index.ts
@@ -0,0 +1 @@
+export { create } from './DataSourceEngine';
diff --git a/packages/datasource-engine/src/handlers/fetch.ts b/packages/datasource-engine/src/handlers/fetch.ts
new file mode 100644
index 000000000..d0f6d344b
--- /dev/null
+++ b/packages/datasource-engine/src/handlers/fetch.ts
@@ -0,0 +1,24 @@
+import request from 'universal-request';
+import type { AsObject, RequestOptions } from 'universal-request/lib/types';
+
+import { DataSourceOptions, RequestHandler } from '../types';
+
+const fetchHandler: RequestHandler = async ({
+  url,
+  uri,
+  data,
+  params,
+  ...otherOptions
+}: DataSourceOptions) => {
+  const reqOptions = {
+    url: ((url || uri) as unknown) as string,
+    data: ((data || params) as unknown) as AsObject,
+    ...otherOptions,
+  };
+
+  const res = await request(reqOptions as RequestOptions);
+
+  return res;
+};
+
+export default fetchHandler;
diff --git a/packages/datasource-engine/src/handlers/mtop.ts b/packages/datasource-engine/src/handlers/mtop.ts
new file mode 100644
index 000000000..4894b9ad9
--- /dev/null
+++ b/packages/datasource-engine/src/handlers/mtop.ts
@@ -0,0 +1,18 @@
+import mtop from '@ali/universal-mtop';
+import { RequestHandler } from '../types';
+
+const mtopHandler: RequestHandler = async (options) => {
+  const { api, uri, data, params, type, method, ...otherOptions } = options;
+  const reqOptions = {
+    ...otherOptions,
+    api: api || uri,
+    data: data || params,
+    type: type || method,
+  };
+
+  const res = await mtop(reqOptions);
+
+  return res;
+};
+
+export default mtopHandler;
diff --git a/packages/datasource-engine/src/handlers/url-params.ts b/packages/datasource-engine/src/handlers/url-params.ts
new file mode 100644
index 000000000..67540c9f2
--- /dev/null
+++ b/packages/datasource-engine/src/handlers/url-params.ts
@@ -0,0 +1,12 @@
+import qs from 'query-string';
+import { RequestHandler } from '../types';
+
+export default function urlParamsHandler(search: string | Record<string, unknown>): RequestHandler {
+  const urlParams = typeof search === 'string' ? qs.parse(search) : search;
+
+  return async () => {
+    return {
+      data: urlParams,
+    };
+  };
+}
diff --git a/packages/datasource-engine/src/index.ts b/packages/datasource-engine/src/index.ts
new file mode 100644
index 000000000..a5a9e0535
--- /dev/null
+++ b/packages/datasource-engine/src/index.ts
@@ -0,0 +1,2 @@
+export * from './core';
+export * from './types';
diff --git a/packages/datasource-engine/src/types/DataSourceConfig.ts b/packages/datasource-engine/src/types/DataSourceConfig.ts
new file mode 100644
index 000000000..8a3687834
--- /dev/null
+++ b/packages/datasource-engine/src/types/DataSourceConfig.ts
@@ -0,0 +1,6 @@
+import { DataSourceConfigItem } from './DataSourceConfigItem';
+
+export type DataSourceConfig = {
+  list?: DataSourceConfigItem[];
+  dataHandler?: (dataMap: Record<string, unknown>) => void | Promise<void>;
+};
diff --git a/packages/datasource-engine/src/types/DataSourceConfigItem.ts b/packages/datasource-engine/src/types/DataSourceConfigItem.ts
new file mode 100644
index 000000000..a8aa46965
--- /dev/null
+++ b/packages/datasource-engine/src/types/DataSourceConfigItem.ts
@@ -0,0 +1,17 @@
+import { DataSourceOptions } from './DataSourceOptions';
+import { RequestHandler } from './RequestHandler';
+
+export type DataSourceConfigItem = {
+  id: string;
+  type: string;
+  isInit?: boolean | (() => boolean | undefined);
+
+  options?: DataSourceOptions | (() => DataSourceOptions | undefined);
+
+  requestHandler?: RequestHandler;
+
+  dataHandler?: (
+    data: unknown | undefined,
+    error: unknown | undefined,
+  ) => unknown;
+};
diff --git a/packages/datasource-engine/src/types/DataSourceEngineOptions.ts b/packages/datasource-engine/src/types/DataSourceEngineOptions.ts
new file mode 100644
index 000000000..f2fd84b1a
--- /dev/null
+++ b/packages/datasource-engine/src/types/DataSourceEngineOptions.ts
@@ -0,0 +1,7 @@
+import { RequestHandler } from './RequestHandler';
+
+export type DataSourceEngineOptions = {
+  requestHandlersMap?: {
+    [dataSourceType: string]: RequestHandler;
+  };
+};
diff --git a/packages/datasource-engine/src/types/DataSourceOptions.ts b/packages/datasource-engine/src/types/DataSourceOptions.ts
new file mode 100644
index 000000000..55a317496
--- /dev/null
+++ b/packages/datasource-engine/src/types/DataSourceOptions.ts
@@ -0,0 +1,10 @@
+export type DataSourceOptions<TParams = Record<string, unknown>> = {
+  uri?: string;
+  params?: TParams;
+  method?: string;
+  isCors?: boolean;
+  timeout?: number;
+  headers?: Record<string, string>;
+  isSync?: boolean;
+  [key: string]: unknown;
+};
diff --git a/packages/datasource-engine/src/types/DataSourceResponse.ts b/packages/datasource-engine/src/types/DataSourceResponse.ts
new file mode 100644
index 000000000..36bd45fff
--- /dev/null
+++ b/packages/datasource-engine/src/types/DataSourceResponse.ts
@@ -0,0 +1,3 @@
+export type DataSourceResponse<TData = unknown> = {
+  data: TData;
+};
diff --git a/packages/datasource-engine/src/types/IDataSourceEngine.ts b/packages/datasource-engine/src/types/IDataSourceEngine.ts
new file mode 100644
index 000000000..4d19be842
--- /dev/null
+++ b/packages/datasource-engine/src/types/IDataSourceEngine.ts
@@ -0,0 +1,9 @@
+import { IRuntimeDataSource } from './IRuntimeDataSource';
+
+export interface IDataSourceEngine {
+  /** 数据源, key 是数据源的 ID */
+  readonly dataSourceMap: Record<string, IRuntimeDataSource>;
+
+  /** 重新加载所有的数据源 */
+  reloadDataSource(): Promise<void>;
+}
diff --git a/packages/datasource-engine/src/types/IDataSourceEngineFactory.ts b/packages/datasource-engine/src/types/IDataSourceEngineFactory.ts
new file mode 100644
index 000000000..4215049ea
--- /dev/null
+++ b/packages/datasource-engine/src/types/IDataSourceEngineFactory.ts
@@ -0,0 +1,12 @@
+import { DataSourceConfig } from './DataSourceConfig';
+import { DataSourceEngineOptions } from './DataSourceEngineOptions';
+import { IDataSourceEngine } from './IDataSourceEngine';
+import { IRuntimeContext } from './IRuntimeContext';
+
+export interface IDataSourceEngineFactory {
+  create(
+    dataSourceConfig: DataSourceConfig,
+    runtimeContext: IRuntimeContext,
+    options?: DataSourceEngineOptions,
+  ): IDataSourceEngine;
+}
diff --git a/packages/datasource-engine/src/types/IRuntimeContext.ts b/packages/datasource-engine/src/types/IRuntimeContext.ts
new file mode 100644
index 000000000..4fed73205
--- /dev/null
+++ b/packages/datasource-engine/src/types/IRuntimeContext.ts
@@ -0,0 +1,24 @@
+import { IRuntimeDataSource } from './IRuntimeDataSource';
+
+/** 运行时上下文 */
+export interface IRuntimeContext<
+  TState extends object = Record<string, unknown>
+> {
+  /** 当前容器的状态 */
+  readonly state: TState;
+
+  /** 设置状态(浅合并) */
+  setState(state: Partial<TState>): void;
+
+  /** 数据源, key 是数据源的 ID */
+  dataSourceMap: Record<string, IRuntimeDataSource>;
+
+  /** 重新加载所有的数据源 */
+  reloadDataSource(): Promise<void>;
+
+  /** 页面容器 */
+  readonly page: IRuntimeContext & { props: Record<string, unknown> };
+
+  /** 低代码业务组件容器 */
+  readonly component: IRuntimeContext & { props: Record<string, unknown> };
+}
diff --git a/packages/datasource-engine/src/types/IRuntimeDataSource.ts b/packages/datasource-engine/src/types/IRuntimeDataSource.ts
new file mode 100644
index 000000000..ccf133716
--- /dev/null
+++ b/packages/datasource-engine/src/types/IRuntimeDataSource.ts
@@ -0,0 +1,22 @@
+import { RuntimeDataSourceStatus } from './RuntimeDataSourceStatus';
+
+/**
+ * 运行时的数据源（对外暴露的接口）
+ * @see https://yuque.antfin-inc.com/mo/spec/spec-low-code-building-schema#Jwgj5
+ */
+export interface IRuntimeDataSource<TParams = unknown, TResultData = unknown> {
+  /** 当前状态(initial/loading/loaded/error) */
+  readonly status: RuntimeDataSourceStatus;
+
+  /** 加载成功时的数据 */
+  readonly data?: TResultData;
+
+  /** 加载出错的时候的错误信息 */
+  readonly error?: Error;
+
+  /**
+   * 加载数据 (无论是否曾经加载过)
+   * 注意：若提供 params，则会和默认配置的参数做浅合并；否则会使用默认配置的参数。
+   */
+  load(params?: TParams): Promise<TResultData>;
+}
diff --git a/packages/datasource-engine/src/types/RequestHandler.ts b/packages/datasource-engine/src/types/RequestHandler.ts
new file mode 100644
index 000000000..c8a96f099
--- /dev/null
+++ b/packages/datasource-engine/src/types/RequestHandler.ts
@@ -0,0 +1,7 @@
+import { DataSourceOptions } from './DataSourceOptions';
+import { DataSourceResponse } from './DataSourceResponse';
+
+export type RequestHandler<
+  TOptions extends DataSourceOptions = DataSourceOptions,
+  TResult extends DataSourceResponse = DataSourceResponse
+> = (options: TOptions) => Promise<TResult>;
diff --git a/packages/datasource-engine/src/types/RuntimeDataSourceStatus.ts b/packages/datasource-engine/src/types/RuntimeDataSourceStatus.ts
new file mode 100644
index 000000000..e089860ab
--- /dev/null
+++ b/packages/datasource-engine/src/types/RuntimeDataSourceStatus.ts
@@ -0,0 +1,14 @@
+/** 数据源的状态 */
+export enum RuntimeDataSourceStatus {
+  /** 初始状态，尚未加载 */
+  Initial = 'init',
+
+  /** 正在加载 */
+  Loading = 'loading',
+
+  /** 已加载(无错误) */
+  Loaded = 'loaded',
+
+  /** 加载出错了 */
+  Error = 'error',
+}
diff --git a/packages/datasource-engine/src/types/index.ts b/packages/datasource-engine/src/types/index.ts
new file mode 100644
index 000000000..31f0f3947
--- /dev/null
+++ b/packages/datasource-engine/src/types/index.ts
@@ -0,0 +1 @@
+export * from './DataSourceConfig';
export * from './DataSourceConfigItem';
export * from './DataSourceEngineOptions';
export * from './DataSourceOptions';
export * from './IDataSourceEngine';
export * from './IDataSourceEngineFactory';
export * from './IRuntimeContext';
export * from './IRuntimeDataSource';
export * from './RequestHandler';
export * from './RuntimeDataSourceStatus';
\ No newline at end of file
diff --git a/packages/datasource-engine/src/typing.d.ts b/packages/datasource-engine/src/typing.d.ts
new file mode 100644
index 000000000..2a2deec30
--- /dev/null
+++ b/packages/datasource-engine/src/typing.d.ts
@@ -0,0 +1 @@
+declare module '@ali/universal-mtop';
diff --git a/packages/types/src/code-intermediate.ts b/packages/types/src/code-intermediate.ts
new file mode 100644
index 000000000..656df2e1e
--- /dev/null
+++ b/packages/types/src/code-intermediate.ts
@@ -0,0 +1,14 @@
+export interface PackageJSON {
+  name: string;
+  version: string;
+  description?: string;
+  dependencies: Record<string, string>;
+  devDependencies: Record<string, string>;
+  scripts?: Record<string, string>;
+  engines?: Record<string, string>;
+  repository?: {
+    type: string;
+    url: string;
+  };
+  private?: boolean;
+}
diff --git a/packages/types/src/code-result.ts b/packages/types/src/code-result.ts
new file mode 100644
index 000000000..07e9c0795
--- /dev/null
+++ b/packages/types/src/code-result.ts
@@ -0,0 +1,59 @@
+/**
+ * 导出内容结构，文件夹
+ *
+ * @export
+ * @interface ResultDir
+ */
+export interface ResultDir {
+  /**
+   * 文件夹名称，Root 名称默认为 .
+   *
+   * @type {string}
+   * @memberof ResultDir
+   */
+  name: string;
+  /**
+   * 子目录
+   *
+   * @type {ResultDir[]}
+   * @memberof ResultDir
+   */
+  dirs: ResultDir[];
+  /**
+   * 文件夹内文件
+   *
+   * @type {ResultFile[]}
+   * @memberof ResultDir
+   */
+  files: ResultFile[];
+}
+
+/**
+ * 导出内容，对文件的描述
+ *
+ * @export
+ * @interface ResultFile
+ */
+export interface ResultFile {
+  /**
+   * 文件名
+   *
+   * @type {string}
+   * @memberof ResultFile
+   */
+  name: string;
+  /**
+   * 文件类型扩展名，例如 .js .less
+   *
+   * @type {string}
+   * @memberof ResultFile
+   */
+  ext: string;
+  /**
+   * 文件内容
+   *
+   * @type {string}
+   * @memberof ResultFile
+   */
+  content: string;
+}
diff --git a/packages/types/src/data-source.ts b/packages/types/src/data-source.ts
index 742a4f9d4..157e65648 100644
--- a/packages/types/src/data-source.ts
+++ b/packages/types/src/data-source.ts
@@ -1,16 +1,32 @@
-import { CompositeValue } from './value-type';
+import { CompositeValue, JSExpression, JSFunction, JSONObject } from './value-type';
 
+/**
+ * 数据源对象
+ * @see https://yuque.antfin-inc.com/mo/spec/spec-low-code-building-schema#XMeF5
+ */
 export interface DataSourceConfig {
   id: string;
-  isInit: boolean;
-  type: string;
-  options: {
-    uri: string;
+  isInit?: boolean | JSExpression;
+  type?: string;
+  requestHandler?: JSFunction;
+  dataHandler?: JSFunction;
+  options?: {
+    uri: string | JSExpression;
+    params?: JSONObject | JSExpression;
+    method?: string | JSExpression;
+    isCors?: boolean | JSExpression;
+    timeout?: number | JSExpression;
+    headers?: JSONObject | JSExpression;
     [option: string]: CompositeValue;
   };
   [otherKey: string]: CompositeValue;
 }
 
+/**
+ * 数据源对象
+ * @see https://yuque.antfin-inc.com/mo/spec/spec-low-code-building-schema#XMeF5
+ */
 export interface DataSource {
   list: DataSourceConfig[];
+  dataHandler?: JSFunction;
 }
diff --git a/packages/types/src/index.ts b/packages/types/src/index.ts
index d8f66a46c..56ff2826b 100644
--- a/packages/types/src/index.ts
+++ b/packages/types/src/index.ts
@@ -15,3 +15,5 @@ export * from './setter-config';
 export * from './setting-target';
 export * from './node';
 export * from './transform-stage';
+export * from './code-intermediate';
+export * from './code-result';
diff --git a/packages/types/src/schema.ts b/packages/types/src/schema.ts
index 9002d6594..590618a31 100644
--- a/packages/types/src/schema.ts
+++ b/packages/types/src/schema.ts
@@ -1,18 +1,20 @@
 import { ComponentsMap } from './npm';
-import { CompositeValue, JSExpression, CompositeObject, JSONObject } from './value-type';
+import { CompositeValue, JSExpression, JSFunction, CompositeObject, JSONObject } from './value-type';
 import { DataSource } from './data-source';
 import { I18nMap } from './i18n';
 import { UtilsMap } from './utils';
 
+// 搭建基础协议 - 单个组件树节点描述
+// 转换成一个 .jsx 文件内 React Class 类 render 函数返回的 jsx 代码
 export interface NodeSchema {
   id?: string;
-  componentName: string;
-  props?: PropsMap | PropsList;
+  componentName: string; // 组件名称 必填、首字母大写
+  props?: PropsMap | PropsList; // 组件属性对象
   leadingComponents?: string;
-  condition?: CompositeValue;
-  loop?: CompositeValue;
-  loopArgs?: [string, string];
-  children?: NodeData | NodeData[];
+  condition?: CompositeValue; // 渲染条件
+  loop?: CompositeValue; // 循环数据
+  loopArgs?: [string, string]; // 循环迭代对象、索引名称 ["item", "index"]
+  children?: NodeData | NodeData[]; // 子节点
 
   // ------- future support -----
   conditionGroup?: string;
@@ -30,6 +32,7 @@ export type PropsList = Array<{
 }>;
 
 export type NodeData = NodeSchema | JSExpression | DOMText;
+export type NodeDataType = NodeData | NodeData[];
 
 export function isDOMText(data: any): data is DOMText {
   return typeof data === 'string';
@@ -45,31 +48,43 @@ export interface ContainerSchema extends NodeSchema {
     [key: string]: CompositeValue;
   };
   methods?: {
-    [key: string]: JSExpression;
+    [key: string]: JSExpression | JSFunction;
   };
   lifeCycles?: {
-    [key: string]: JSExpression;
+    [key: string]: JSExpression | JSFunction;
   };
   css?: string;
   dataSource?: DataSource;
   defaultProps?: CompositeObject;
 }
 
+/**
+ * 页面容器
+ * @see https://yuque.antfin-inc.com/mo/spec/spec-low-code-building-schema#XMeF5
+ */
 export interface PageSchema extends ContainerSchema {
   componentName: 'Page';
 }
 
+/**
+ * 低代码业务组件容器
+ * @see https://yuque.antfin-inc.com/mo/spec/spec-low-code-building-schema#XMeF5
+ */
 export interface ComponentSchema extends ContainerSchema {
   componentName: 'Component';
 }
 
-export type RootSchema = PageSchema | ComponentSchema;
-
-export interface BlockSchema extends NodeSchema {
+/**
+ * 区块容器
+ * @see https://yuque.antfin-inc.com/mo/spec/spec-low-code-building-schema#XMeF5
+ */
+export interface BlockSchema extends ContainerSchema {
   componentName: 'Block';
 }
+
+export type RootSchema = PageSchema | ComponentSchema | BlockSchema;
+
 export interface SlotSchema extends NodeSchema {
-  name?: string;
   componentName: 'Slot';
   params?: string[];
 }
diff --git a/packages/types/src/utils.ts b/packages/types/src/utils.ts
index 751317f84..b8ac406ef 100644
--- a/packages/types/src/utils.ts
+++ b/packages/types/src/utils.ts
@@ -1,13 +1,17 @@
 import { NpmInfo } from './npm';
+import { JSExpression, JSFunction } from './value-type';
 
-export type UtilsMap = Array<
-| {
+export type InternalUtils = {
   name: string;
-  type: 'npm';
+  type: 'function';
+  content: JSFunction | JSExpression;
+};
+
+export type ExternalUtils = {
+  name: string;
+  type: 'npm' | 'tnpm';
   content: NpmInfo;
-}
-| {
-  name: string;
-  type: '';
-}
->;
+};
+
+export type UtilItem = InternalUtils | ExternalUtils;
+export type UtilsMap = UtilItem[];
diff --git a/packages/types/src/value-type.ts b/packages/types/src/value-type.ts
index 14eea7ad4..7aa964620 100644
--- a/packages/types/src/value-type.ts
+++ b/packages/types/src/value-type.ts
@@ -11,10 +11,31 @@ export interface JSExpression {
    * 模拟值
    */
   mock?: any;
+}
+
+// 函数
+export interface JSFunction {
+  type: 'JSFunction';
   /**
-   * 额外扩展属性，如 extType、events
+   * 表达式字符串
    */
-  [key: string]: any;
+  value: string;
+}
+
+/**
+ * 事件函数类型
+ * @see https://yuque.antfin-inc.com/mo/spec/spec-low-code-building-schema#feHTW
+ */
+export interface JSFunction {
+  type: 'JSFunction';
+
+  /**
+   * 函数定义，或直接函数表达式
+   */
+  value: string;
+
+  /** 源码 */
+  compiled?: string;
 }
 
 // 函数
@@ -35,7 +56,6 @@ export interface JSFunction{
 }
 
 export interface JSSlot {
-  name?: string;
   type: 'JSSlot';
   title?: string;
   // 函数的入参
@@ -56,23 +76,20 @@ export interface JSONObject {
 }
 
 // 复合类型
-export type CompositeValue = JSONValue | JSExpression | JSSlot | CompositeArray | CompositeObject | JSFunction;
+export type CompositeValue = JSONValue | JSExpression | JSFunction | JSSlot | CompositeArray | CompositeObject;
 export type CompositeArray = CompositeValue[];
 export interface CompositeObject {
   [key: string]: CompositeValue;
 }
 
-
 export function isJSExpression(data: any): data is JSExpression {
   return data && data.type === 'JSExpression';
 }
 
-
-export function isJSFunction(data: any): data is JSFunction {
-  return data && data.type === 'JSFunction';
+export function isJSFunction(x: any): x is JSFunction {
+  return typeof x === 'object' && x && x.type === 'JSFunction';
 }
 
-
 export function isJSSlot(data: any): data is JSSlot {
   return data && data.type === 'JSSlot';
 }
